Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/create_boundary.f90	(revision 5075)
@@ -625,153 +906,169 @@
          END SELECT   
 
-         DO jl=1,tl_bdy(jk)%i_nseg
-            !- concatenate variable
-            IF( jl == 1 )THEN
-               tl_lon1(jk)=tl_seglon1(jk,jl)
-               tl_lat1(jk)=tl_seglat1(jk,jl)
-               DO jvar=1,tl_multi%i_nvar
-                  tl_var(jvar,jk)=tl_segvar1(jvar,jk,jl)
-               ENDDO
+         DO jk=1,tl_bdy(jl)%i_nseg
+            !- 
+            CALL create_boundary_get_coord( tl_coord1, tl_segdom1(jp_T,jk,jl),&
+            &                               'T', tl_lon1, tl_lat1 )
+
+            ! del extra point on fine grid
+            CALL dom_del_extra( tl_lon1, tl_segdom1(jp_T,jk,jl) )
+            CALL dom_del_extra( tl_lat1, tl_segdom1(jp_T,jk,jl) )
+
+            ! clean
+            DO jpoint=1,ip_npoint
+               CALL dom_clean(tl_segdom1(jpoint,jk,jl))
+            ENDDO
+
+            ! swap array
+            CALL boundary_swap(tl_lon1, tl_bdy(jl))
+            CALL boundary_swap(tl_lat1, tl_bdy(jl))
+            DO jvar=1,tl_multi%i_nvar
+               CALL boundary_swap(tl_segvar1(jvar,jk,jl), tl_bdy(jl))
+
+               ! use additional request
+               ! forced min and max value
+               CALL var_limit_value(tl_segvar1(jvar,jk,jl))
+
+               ! filter
+               CALL filter_fill_value(tl_segvar1(jvar,jk,jl))
+
+               ! extrapolate
+               CALL extrap_fill_value( tl_segvar1(jvar,jk,jl), &
+               &                       id_iext=in_extrap,      &
+               &                       id_jext=in_extrap,      &
+               &                       id_kext=in_extrap )
+
+            ENDDO
+
+            ! create file
+            ! create file structure
+            ! set file namearray of level variable structure
+            IF( ASSOCIATED(tl_time%d_value) )THEN
+               cl_fmt="('y',i0.4,'m',i0.2,'d',i0.2)"
+               cl_date=date_print( var_to_date(tl_time), cl_fmt ) 
+
+               cl_bdyout=boundary_set_filename( TRIM(cn_fileout), &
+               &                                TRIM(tl_bdy(jl)%c_card), jk, TRIM(cl_date) )
             ELSE
-               tl_lon1(jk)=var_concat(tl_lon1(jk),tl_seglon1(jk,jl),DIM=il_dim)
-               tl_lat1(jk)=var_concat(tl_lat1(jk),tl_seglat1(jk,jl),DIM=il_dim)
-               DO jvar=1,tl_multi%i_nvar
-                  tl_var(jvar,jk)=var_concat(tl_var(jvar,jk),tl_segvar1(jvar,jk,jl),DIM=il_dim)
-               ENDDO
-            ENDIF   
-         ENDDO
-
-         ! swap array
-         CALL boundary_swap(tl_lon1(jk), tl_bdy(jk))
-         CALL boundary_swap(tl_lat1(jk), tl_bdy(jk))
-         DO jvar=1,tl_multi%i_nvar
-            CALL boundary_swap(tl_var(jvar,jk), tl_bdy(jk))
-
-            !9- use additional request
-
-            !9-1 forced min and max value
-            CALL var_limit_value(tl_var(jvar,jk))
-
-            !9-2 filter
-            CALL filter_fill_value(tl_var(jvar,jk))
-
-            !9-3 extrapolate
-            CALL extrap_fill_value(tl_var(jvar,jk), id_iext=in_extrap, &
-            &                                       id_jext=in_extrap, &
-            &                                       id_kext=in_extrap)
-
-         ENDDO
+               cl_bdyout=boundary_set_filename( TRIM(cn_fileout), &
+               &                                TRIM(tl_bdy(jl)%c_card), jk )
+            ENDIF
+            ! 
+            tl_fileout=file_init(TRIM(cl_bdyout),id_perio=in_perio1)
+
+            ! add dimension
+            tl_dim(:)=var_max_dim(tl_segvar1(:,jk,jl))
+
+            CALL dim_unorder(tl_dim(:))
+            SELECT CASE(TRIM(tl_bdy(jl)%c_card))
+               CASE DEFAULT ! 'north','south'
+                  cl_dimorder='xyzt'
+                  CALL dim_reorder(tl_dim(:),TRIM(cl_dimorder))
+               CASE('east','west')
+                  cl_dimorder='yxzt'
+                  CALL dim_reorder(tl_dim(:),TRIM(cl_dimorder))
+                  ! reorder coordinates dimension
+                  CALL var_reorder(tl_lon1,TRIM(cl_dimorder))
+                  CALL var_reorder(tl_lat1,TRIM(cl_dimorder))
+                  ! reorder other variable dimension
+                  DO jvar=1,tl_multi%i_nvar
+                     CALL var_reorder(tl_segvar1(jvar,jk,jl),TRIM(cl_dimorder))
+                  ENDDO
+            END SELECT
+
+            DO ji=1,ip_maxdim
+               IF( tl_dim(ji)%l_use ) CALL file_add_dim(tl_fileout, tl_dim(ji))
+            ENDDO
+
+            ! add variables
+            IF( ALL( tl_dim(1:2)%l_use ) )THEN
+               ! add longitude
+               CALL file_add_var(tl_fileout, tl_lon1)
+               CALL var_clean(tl_lon1)
+
+               ! add latitude
+               CALL file_add_var(tl_fileout, tl_lat1)
+               CALL var_clean(tl_lat1)
+            ENDIF
+            
+            IF( tl_dim(3)%l_use )THEN
+               ! add depth
+               CALL file_add_var(tl_fileout, tl_depth)
+            ENDIF
+
+            IF( tl_dim(4)%l_use )THEN
+               ! add time
+               CALL file_add_var(tl_fileout, tl_time)
+            ENDIF
+
+            ! add other variable
+            DO jvar=1,tl_multi%i_nvar
+               CALL file_add_var(tl_fileout, tl_segvar1(jvar,jk,jl))
+               CALL var_clean(tl_segvar1(jvar,jk,jl))
+            ENDDO
+
+            ! add some attribute
+            tl_att=att_init("Created_by","SIREN create_boundary")
+            CALL file_add_att(tl_fileout, tl_att)
+
+            cl_date=date_print(date_now())
+            tl_att=att_init("Creation_date",cl_date)
+            CALL file_add_att(tl_fileout, tl_att)
+
+            ! add shift on north and east boundary
+            ! boundary compute on T point but express on U or V point
+            SELECT CASE(TRIM(tl_bdy(jl)%c_card))
+            CASE DEFAULT ! 'south','west'
+               il_shift=0
+            CASE('north','east')
+               il_shift=1
+            END SELECT
+
+            ! add indice of velocity row or column
+            tl_att=att_init('bdy_ind',tl_bdy(jl)%t_seg(jk)%i_index-il_shift)
+            CALL file_move_att(tl_fileout, tl_att)
+
+            ! add width of the relaxation zone
+            tl_att=att_init('bdy_width',tl_bdy(jl)%t_seg(jk)%i_width)
+            CALL file_move_att(tl_fileout, tl_att)
+            
+            ! add indice of segment start 
+            tl_att=att_init('bdy_deb',tl_bdy(jl)%t_seg(jk)%i_first)
+            CALL file_move_att(tl_fileout, tl_att)
+            
+            ! add indice of segment end 
+            tl_att=att_init('bdy_end',tl_bdy(jl)%t_seg(jk)%i_last)
+            CALL file_move_att(tl_fileout, tl_att)
+                           
+            ! clean
+            CALL att_clean(tl_att)
+
+            ! create file
+            CALL iom_create(tl_fileout)
+
+            ! write file
+            CALL iom_write_file(tl_fileout)
+
+            ! close file
+            CALL iom_close(tl_fileout)
+            CALL file_clean(tl_fileout)
+
+         ENDDO ! jk
+
       ENDIF
-   ENDDO
-
-   DEALLOCATE( tl_seglon1 )
-   DEALLOCATE( tl_seglat1 )
+      ! clean
+      CALL boundary_clean(tl_bdy(jl))
+   ENDDO !jl
+
+   ! clean
+   IF( ASSOCIATED(tl_depth%d_value) ) CALL var_clean(tl_depth)
+   IF( ASSOCIATED(tl_time%d_value) )   CALL var_clean(tl_time)
    DEALLOCATE( tl_segdom1 )
    DEALLOCATE( tl_segvar1 )
-   DEALLOCATE( tl_seglvl1 )
-   
-   DO jk=1,ip_ncard
-      IF( tl_bdy(jk)%l_use )THEN
-
-         !10   create file
-         !10-1 create file structure
-         !10-1-1 set file name
-         cl_bdyout=boundary_set_filename( TRIM(cn_fileout), &
-         &                                TRIM(tl_bdy(jk)%c_card) )
-         !10-1-2 
-         tl_fileout=file_init(TRIM(cl_bdyout),id_perio=in_perio1)
-
-         !10-2 add dimension
-         tl_dim(:)=var_max_dim(tl_var(:,jk))
-
-         DO ji=1,ip_maxdim
-            IF( tl_dim(ji)%l_use ) CALL file_add_dim(tl_fileout, tl_dim(ji))
-         ENDDO
-
-         !10-3 add variables
-         IF( ALL( tl_dim(1:2)%l_use ) )THEN
-            ! add longitude
-            CALL file_add_var(tl_fileout, tl_lon1(jk))
-            CALL var_clean(tl_lon1(jk))
-
-            ! add latitude
-            CALL file_add_var(tl_fileout, tl_lat1(jk))
-            CALL var_clean(tl_lat1(jk))
-         ENDIF
-         
-         IF( tl_dim(3)%l_use )THEN
-            ! add depth
-            CALL file_add_var(tl_fileout, tl_depth)
-         ENDIF
-
-         IF( tl_dim(4)%l_use )THEN
-            ! add time
-            CALL file_add_var(tl_fileout, tl_time)
-         ENDIF
-
-         ! add other variable
-         DO jvar=1,tl_multi%i_nvar
-            !IF( TRIM(tl_var(jvar,jk)%c_name) /= 'X' .AND. &
-            !&   TRIM(tl_var(jvar,jk)%c_name) /= 'Y' )THEN
-               CALL file_add_var(tl_fileout, tl_var(jvar,jk))
-            !ENDIF
-            CALL var_clean(tl_var(jvar,jk))
-         ENDDO
-
-         !10-4 add some attribute
-         tl_att=att_init("Created_by","SIREN create_boundary")
-         CALL file_add_att(tl_fileout, tl_att)
-
-         cl_date=date_print(date_now())
-         tl_att=att_init("Creation_date",cl_date)
-         CALL file_add_att(tl_fileout, tl_att)
-
-         ! add attribute periodicity
-         il_attid=0
-         IF( ASSOCIATED(tl_fileout%t_att) )THEN
-            il_attid=att_get_id(tl_fileout%t_att(:),'periodicity')
-         ENDIF
-         IF( tl_coord1%i_perio >= 0 .AND. il_attid == 0 )THEN
-            tl_att=att_init('periodicity',tl_coord1%i_perio)
-            CALL file_add_att(tl_fileout,tl_att)
-         ENDIF
-      
-         il_attid=0
-         IF( ASSOCIATED(tl_fileout%t_att) )THEN
-            il_attid=att_get_id(tl_fileout%t_att(:),'ew_overlap')
-         ENDIF
-         IF( tl_coord1%i_ew >= 0 .AND. il_attid == 0 )THEN
-            tl_att=att_init('ew_overlap',tl_coord1%i_ew)
-            CALL file_add_att(tl_fileout,tl_att)
-         ENDIF
-
-         !10-5 create file
-         CALL iom_create(tl_fileout)
-
-         !10-6 write file
-         CALL iom_write_file(tl_fileout)
-
-         !10-7 close file
-         CALL iom_close(tl_fileout)
-         CALL file_clean(tl_fileout)
-
-      ENDIF
-   ENDDO
-   DEALLOCATE( tl_lon1 ) 
-   DEALLOCATE( tl_lat1 ) 
-   DEALLOCATE( tl_var ) 
-
-   !11- close file
-   CALL iom_close(tl_bathy1)
-   CALL iom_close(tl_coord1)
-   CALL iom_close(tl_coord0)
-
-   !12- clean
-   CALL var_clean(tl_depth)
-   CALL var_clean(tl_time)
-   CALL file_clean(tl_fileout)
-   CALL file_clean(tl_bathy1)
-   CALL file_clean(tl_coord1)
-   CALL file_clean(tl_coord0)
+
+   CALL mpp_clean(tl_coord1)
+   CALL mpp_clean(tl_coord0)
+
+   CALL multi_clean(tl_multi)
 
    ! close log file
@@ -779,19 +1076,19 @@
    CALL logger_close()
 
-!> @endcode
 CONTAINS
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine compute boundary domain for each grid point (T,U,V,F) 
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - take into account grid point to compute boundary indices
    !>
-   !> @author J.Paul
-   !> - 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] td_bathy1 file structure 
+   !> @param[in] td_bdy    boundary structure
+   !> @param[in] id_seg    segment indice 
+   !> @return array of domain structure 
+   !-------------------------------------------------------------------
    FUNCTION create_boundary_get_dom( td_bathy1, td_bdy, id_seg )
 
@@ -799,10 +1096,10 @@
 
       ! Argument
-      TYPE(TFILE), INTENT(IN   ) :: td_bathy1
+      TYPE(TMPP) , INTENT(IN   ) :: td_bathy1
       TYPE(TBDY) , INTENT(IN   ) :: td_bdy
       INTEGER(i4), INTENT(IN   ) :: id_seg
 
       ! function
-      TYPE(TDOM) :: create_boundary_get_dom
+      TYPE(TDOM), DIMENSION(ip_npoint) :: create_boundary_get_dom
 
       ! local variable
@@ -812,60 +1109,133 @@
       INTEGER(i4) :: il_jmax1
 
-      TYPE(TFILE) :: tl_bathy1
-      
+      INTEGER(i4) :: il_imin
+      INTEGER(i4) :: il_imax
+      INTEGER(i4) :: il_jmin
+      INTEGER(i4) :: il_jmax
+
+      INTEGER(i4), DIMENSION(ip_npoint) :: il_ishift
+      INTEGER(i4), DIMENSION(ip_npoint) :: il_jshift
+
       ! loop indices
-      INTEGER(i4) :: jl
+      INTEGER(i4) :: ji
+      INTEGER(i4) :: jk
       !----------------------------------------------------------------
-      jl=id_seg
-
-      !1- get boundary definition
+      ! init
+      jk=id_seg
+
+      il_ishift(:)=0
+      il_jshift(:)=0
+
+      ! get boundary definition
       SELECT CASE(TRIM(td_bdy%c_card))
          CASE('north')
 
-            il_imin1=td_bdy%t_seg(jl)%i_first
-            il_imax1=td_bdy%t_seg(jl)%i_last 
-            il_jmin1=td_bdy%t_seg(jl)%i_index-(td_bdy%t_seg(jl)%i_width-1)
-            il_jmax1=td_bdy%t_seg(jl)%i_index
+            il_imin1=td_bdy%t_seg(jk)%i_first
+            il_imax1=td_bdy%t_seg(jk)%i_last 
+            il_jmin1=td_bdy%t_seg(jk)%i_index-(td_bdy%t_seg(jk)%i_width-1)
+            il_jmax1=td_bdy%t_seg(jk)%i_index
+
+            il_jshift(jp_V)=-1
+            il_jshift(jp_F)=-1
 
          CASE('south')
 
-            il_imin1=td_bdy%t_seg(jl)%i_first
-            il_imax1=td_bdy%t_seg(jl)%i_last 
-            il_jmin1=td_bdy%t_seg(jl)%i_index
-            il_jmax1=td_bdy%t_seg(jl)%i_index+(td_bdy%t_seg(jl)%i_width-1)
+            il_imin1=td_bdy%t_seg(jk)%i_first
+            il_imax1=td_bdy%t_seg(jk)%i_last 
+            il_jmin1=td_bdy%t_seg(jk)%i_index
+            il_jmax1=td_bdy%t_seg(jk)%i_index+(td_bdy%t_seg(jk)%i_width-1)
 
          CASE('east')
 
-            il_imin1=td_bdy%t_seg(jl)%i_index-(td_bdy%t_seg(jl)%i_width-1)
-            il_imax1=td_bdy%t_seg(jl)%i_index
-            il_jmin1=td_bdy%t_seg(jl)%i_first
-            il_jmax1=td_bdy%t_seg(jl)%i_last 
+            il_imin1=td_bdy%t_seg(jk)%i_index-(td_bdy%t_seg(jk)%i_width-1)
+            il_imax1=td_bdy%t_seg(jk)%i_index
+            il_jmin1=td_bdy%t_seg(jk)%i_first
+            il_jmax1=td_bdy%t_seg(jk)%i_last 
+
+            il_ishift(jp_U)=-1
+            il_ishift(jp_F)=-1
 
          CASE('west')
 
-            il_imin1=td_bdy%t_seg(jl)%i_index
-            il_imax1=td_bdy%t_seg(jl)%i_index+(td_bdy%t_seg(jl)%i_width-1)
-            il_jmin1=td_bdy%t_seg(jl)%i_first
-            il_jmax1=td_bdy%t_seg(jl)%i_last 
+            il_imin1=td_bdy%t_seg(jk)%i_index
+            il_imax1=td_bdy%t_seg(jk)%i_index+(td_bdy%t_seg(jk)%i_width-1)
+            il_jmin1=td_bdy%t_seg(jk)%i_first
+            il_jmax1=td_bdy%t_seg(jk)%i_last 
 
       END SELECT         
 
-      !2 -read fine grid domain
-      tl_bathy1=td_bathy1
-      CALL iom_open(tl_bathy1)
-
-      !2-1 compute domain
-      create_boundary_get_dom=dom_init( tl_bathy1,         &
-      &                                 il_imin1, il_imax1,&
-      &                                 il_jmin1, il_jmax1 )
-
-      !2-2 close file
-      CALL iom_close(tl_bathy1)
+      !-read fine grid domain
+      DO ji=1,ip_npoint
+
+         ! shift domain
+         il_imin=il_imin1+il_ishift(ji)
+         il_imax=il_imax1+il_ishift(ji)
+
+         il_jmin=il_jmin1+il_jshift(ji)
+         il_jmax=il_jmax1+il_jshift(ji)
+
+         ! compute domain
+         create_boundary_get_dom(ji)=dom_init( td_bathy1,       &
+         &                                     il_imin, il_imax,&
+         &                                     il_jmin, il_jmax,&
+         &                                     TRIM(td_bdy%c_card) )
+
+      ENDDO
 
    END FUNCTION create_boundary_get_dom
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine get coordinates over boudnary domain
+   !> 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date September, 2014 - take into account grid point
+   !>
+   !> @param[in] td_coord1 coordinates file structure
+   !> @param[in] td_dom1   boundary domain structure
+   !> @param[in] cd_point  grid point
+   !> @param[out] td_lon1  longitude variable structure
+   !> @param[out] td_lat1  latitude variable structure
+   !-------------------------------------------------------------------
+   SUBROUTINE create_boundary_get_coord( td_coord1, td_dom1, cd_point, &
+   &                                     td_lon1, td_lat1 )
+
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP)      , INTENT(IN   ) :: td_coord1
+      TYPE(TDOM)      , INTENT(IN   ) :: td_dom1
+      TYPE(TVAR)      , INTENT(  OUT) :: td_lon1
+      TYPE(TVAR)      , INTENT(  OUT) :: td_lat1 
+      CHARACTER(LEN=*), INTENT(IN   ), OPTIONAL :: cd_point
+
+      ! local variable
+      TYPE(TMPP)  :: tl_coord1
+      
+      CHARACTER(LEN=lc) :: cl_name
+      ! loop indices
+      !----------------------------------------------------------------
+      !read variables on domain (ugly way to do it, have to work on it)
+      ! init mpp structure
+      tl_coord1=mpp_copy(td_coord1)
+      
+      ! open mpp files
+      CALL iom_dom_open(tl_coord1, td_dom1)
+
+      ! read variable value on domain
+      WRITE(cl_name,*) 'longitude_'//TRIM(cd_point)
+      td_lon1=iom_dom_read_var( tl_coord1, TRIM(cl_name), td_dom1)
+      WRITE(cl_name,*) 'latitude_'//TRIM(cd_point)
+      td_lat1=iom_dom_read_var( tl_coord1, TRIM(cl_name), td_dom1)
+
+      ! close mpp files
+      CALL iom_dom_close(tl_coord1)
+
+      ! clean structure
+      CALL mpp_clean(tl_coord1)
+
+   END SUBROUTINE create_boundary_get_coord
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine interpolate variable over boundary
    !> 
    !> @details 
@@ -874,247 +1244,10 @@
    !> - Nov, 2013- Initial Version
    !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE create_boundary_get_coord( td_bathy1, td_dom1, &
-   &                                     td_lon1, td_lat1 )
-
-      IMPLICIT NONE
-
-      ! Argument
-      TYPE(TFILE), INTENT(IN   ) :: td_bathy1
-      TYPE(TDOM) , INTENT(IN   ) :: td_dom1
-      TYPE(TVAR) , INTENT(  OUT) :: td_lon1
-      TYPE(TVAR) , INTENT(  OUT) :: td_lat1 
-
-      ! local variable
-      TYPE(TFILE) :: tl_bathy1
-      
-      TYPE(TMPP)  :: tl_mppbathy1
-
-      ! loop indices
-      !----------------------------------------------------------------
-      !read variables on domain (ugly way to do it, have to work on it)
-
-      !1 init mpp structure
-      tl_bathy1=td_bathy1
-      tl_mppbathy1=mpp_init(tl_bathy1)
-      
-      CALL file_clean(tl_bathy1)
-
-      !2 get processor to be used
-      CALL mpp_get_use( tl_mppbathy1, td_dom1 )
-
-      !3 open mpp files
-      CALL iom_mpp_open(tl_mppbathy1)
-
-      !4 read variable value on domain
-      td_lon1=iom_mpp_read_var(tl_mppbathy1,'longitude',td_dom=td_dom1)
-      td_lat1=iom_mpp_read_var(tl_mppbathy1,'latitude' ,td_dom=td_dom1)
-
-      !5 close mpp files
-      CALL iom_mpp_close(tl_mppbathy1)
-
-      !6 clean structure
-      CALL mpp_clean(tl_mppbathy1)
-
-   END SUBROUTINE create_boundary_get_coord
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> This subroutine
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE create_boundary_get_mask( td_level1, td_dom1, &
-   &                                    td_var, td_mask )
-
-      IMPLICIT NONE
-
-      ! Argument
-      TYPE(TFILE), INTENT(IN   ) :: td_level1
-      TYPE(TDOM) , INTENT(IN   ) :: td_dom1
-      TYPE(TVAR) , INTENT(IN   ) :: td_var
-      TYPE(TVAR) , INTENT(  OUT) :: td_mask 
-
-      ! local variable
-      TYPE(TFILE) :: tl_level1
-      
-      TYPE(TMPP)  :: tl_mpplevel1
-
-      ! loop indices
-      !----------------------------------------------------------------
-      !read variables on domain (ugly way to do it, have to work on it)
-
-      !1 init mpp structure
-      tl_level1=td_level1
-      tl_mpplevel1=mpp_init(tl_level1)
-      
-      CALL file_clean(tl_level1)
-
-      !2 get processor to be used
-      CALL mpp_get_use( tl_mpplevel1, td_dom1 )
-
-      !3 open mpp files
-      CALL iom_mpp_open(tl_mpplevel1)
-
-      !4 read variable value on domain
-      SELECT CASE(TRIM(td_var%c_point))
-      CASE('T')
-         td_mask=iom_mpp_read_var(tl_mpplevel1,'tlevel',td_dom=td_dom1)
-      CASE('U')
-         td_mask=iom_mpp_read_var(tl_mpplevel1,'ulevel',td_dom=td_dom1)
-      CASE('V')
-         td_mask=iom_mpp_read_var(tl_mpplevel1,'vlevel',td_dom=td_dom1)
-      CASE('F')
-         td_mask=iom_mpp_read_var(tl_mpplevel1,'flevel',td_dom=td_dom1)
-      END SELECT
-
-      !5 close mpp files
-      CALL iom_mpp_close(tl_mpplevel1)
-
-      !6 clean structure
-      CALL mpp_clean(tl_mpplevel1)
-
-   END SUBROUTINE create_boundary_get_mask
-   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief
-!   !> This subroutine
-!   !> 
-!   !> @details 
-!   !>
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !>
-!   !> @param[in] 
-!   !> @todo 
-!   !-------------------------------------------------------------------
-!   !> @code
-!   SUBROUTINE create_boundary_get_var( td_var, td_bdy,      &
-!   &                                   td_coord0, td_dom0,  &
-!   &                                   td_mask,             &
-!   &                                   id_rhoi, id_rhoj )
-!
-!      IMPLICIT NONE
-!
-!      ! Argument
-!      TYPE(TVAR) , INTENT(INOUT) :: td_var
-!      TYPE(TBDY) , INTENT(IN   ) :: td_bdy
-!      TYPE(TFILE), INTENT(IN   ) :: td_coord0
-!      TYPE(TDOM) , INTENT(IN   ) :: td_dom0
-!      TYPE(TVAR) , INTENT(IN   ) :: td_mask
-!      INTEGER(I4), INTENT(IN   ) :: id_rhoi
-!      INTEGER(I4), INTENT(IN   ) :: id_rhoj
-!
-!      ! local variable
-!      TYPE(TVAR)  :: tl_var0
-!
-!      TYPE(TDOM)  :: tl_dom0
-!
-!      TYPE(TFILE) :: tl_file0
-!
-!      TYPE(TMPP)  :: tl_mppfile0
-!
-!      ! loop indices
-!      INTEGER(i4) :: jk
-!      INTEGER(i4) :: jl
-!      !----------------------------------------------------------------
-!
-!      CALL logger_debug("CREATE BOUNDARY INTERP: read coarse grid"// TRIM(td_var%c_file) )
-!      !1- read coarse grid variable on domain
-!      tl_file0=file_init( TRIM(td_var%c_file) )
-!
-!      !2- init
-!      tl_dom0=td_dom0
-!
-!      !3- add extra band (if possible) to compute interpolation
-!      CALL dom_add_extra(tl_dom0)
-!
-!      !4- read variables on domain (ugly way to do it, have to work on it)
-!      !4-1 init mpp structure
-!      tl_mppfile0=mpp_init(tl_file0)
-! 
-!      CALL file_clean(tl_file0)
-!
-!      !4-2 get processor to be used
-!      CALL mpp_get_use( tl_mppfile0, tl_dom0 )
-!
-!      !4-3 open mpp files
-!      CALL iom_mpp_open(tl_mppfile0)
-!
-!      ! check file dimension
-!      IF( ANY(tl_mppfile0%t_dim(1:2)%i_len /= td_coord0%t_dim(1:2)%i_len) )THEN
-!         CALL logger_error("CREATE BOUNDARY INTERP: dimension of file "//&
-!         &  TRIM(tl_mppfile0%c_name)//" not conform to those of "//&
-!         &  TRIM(td_coord0%c_name))
-!      ELSE
-!
-!         !4-4 read variable value on domain
-!         tl_var0=iom_mpp_read_var( tl_mppfile0, TRIM(td_var%c_name), &
-!         &                         td_dom=tl_dom0 )
-!
-!         !5- work on variable
-!         CALL create_boundary_interp(tl_var0, id_rhoi, id_rhoj )
-!         
-!         !6- remove extraband added to domain
-!         CALL dom_del_extra( tl_var0, tl_dom0, id_rhoi, id_rhoj )
-!
-!         !6-1 remove extraband added to domain
-!         CALL dom_clean_extra( tl_dom0 )         
-!
-!         !7- keep only useful point (width) 
-!         ! interpolation could create more point than necessary
-!         CALL boundary_clean_interp(tl_var0, td_bdy )
-!
-!         !8- forced min and max value
-!         CALL var_limit_value(tl_var0)
-!
-!         !9- filter
-!         CALL filter_fill_value(tl_var0)
-!
-!         td_var=tl_var0
-!
-!         CALL var_clean(tl_var0)
-!      ENDIF
-!
-!      !4-5 close mpp files
-!      CALL iom_mpp_close(tl_mppfile0)
-!
-!      !4-6 clean structure
-!      CALL mpp_clean(tl_mppfile0)
-!      
-!      !5- apply mask
-!      DO jl=1,td_var%t_dim(4)%i_len
-!         DO jk=1,td_var%t_dim(3)%i_len
-!            WHERE( td_mask%d_value(:,:,1,1) < jk )
-!               td_var%d_value(:,:,jk,jl)=td_var%d_fill
-!            END WHERE
-!         ENDDO
-!      ENDDO
-!
-!   END SUBROUTINE create_boundary_get_var
-!   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief
-   !> This subroutine
-   !> 
-   !> @details 
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[inout] td_var variable structure 
+   !> @param[in] id_rho    array of refinment factor
+   !> @param[in] id_offset array of offset between fine and coarse grid
+   !> @param[in] id_iext   i-direction size of extra bands (default=im_minext)
+   !> @param[in] id_jext   j-direction size of extra bands (default=im_minext)
+   !-------------------------------------------------------------------
    SUBROUTINE create_boundary_interp( td_var,           &
    &                                  id_rho,           &
@@ -1134,13 +1267,8 @@
 
       ! local variable
-      TYPE(TVAR)  :: tl_var
-
       INTEGER(i4) :: il_iext
       INTEGER(i4) :: il_jext
       ! loop indices
       !----------------------------------------------------------------
-
-      ! copy variable
-      tl_var=td_var
 
       !WARNING: at least two extrabands are required for cubic interpolation
@@ -1163,26 +1291,19 @@
       ENDIF
 
-      !2- work on variable
-      !2-0 add extraband
-      CALL extrap_add_extrabands(tl_var, il_iext, il_jext)
-
-      !2-1 extrapolate variable
-      CALL extrap_fill_value( tl_var, id_iext=il_iext, id_jext=il_jext )
-
-      !2-2 interpolate Bathymetry
-      CALL interp_fill_value( tl_var, id_rho(:), &
+      ! work on variable
+      ! add extraband
+      CALL extrap_add_extrabands(td_var, il_iext, il_jext)
+
+      ! extrapolate variable
+      CALL extrap_fill_value( td_var, id_iext=il_iext, id_jext=il_jext )
+
+      ! interpolate Bathymetry
+      CALL interp_fill_value( td_var, id_rho(:), &
       &                       id_offset=id_offset(:,:) )
 
-      !2-3 remove extraband
-      CALL extrap_del_extrabands(tl_var, il_iext*id_rho(jp_I), il_jext*id_rho(jp_J))
-
-      !3- save result
-      td_var=tl_var
-
-      ! clean variable structure
-      CALL var_clean(tl_var)
+      ! remove extraband
+      CALL extrap_del_extrabands(td_var, il_iext*id_rho(jp_I), il_jext*id_rho(jp_J))
 
    END SUBROUTINE create_boundary_interp
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -1192,30 +1313,26 @@
    !> A variable is create with the same name that the input variable, 
    !> and with dimension of the coordinate file. 
-   !> Then the variable table of value is split into equal subdomain.
+   !> Then the variable array of value is split into equal subdomain.
    !> Each subdomain is fill with the linked value of the matrix.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
+   !> - November, 2013- Initial Version
    !>
-   !> @param[in] td_var : variable structure 
-   !> @param[in] td_dom : domain structure 
-   !> @param[in] td_coord : coordinate 
+   !> @param[in] td_var    variable structure 
+   !> @param[in] td_dom    domain structure 
+   !> @param[in] id_nlevel number of levels 
    !> @return variable structure 
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_bdy_matrix(td_var, td_dom, td_coord)
+   FUNCTION create_boundary_matrix(td_var, td_dom, id_nlevel)
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(IN) :: td_var
-      TYPE(TDOM) , INTENT(IN) :: td_dom
-      TYPE(TFILE), INTENT(IN) :: td_coord
+      TYPE(TVAR) ,               INTENT(IN) :: td_var
+      TYPE(TDOM) ,               INTENT(IN) :: td_dom
+      INTEGER(i4),               INTENT(IN) :: id_nlevel
 
       ! function
-      TYPE(TVAR) :: create_bdy_matrix
+      TYPE(TVAR) :: create_boundary_matrix
 
       ! local variable
-      INTEGER(i4)                                        :: il_ighost
-      INTEGER(i4)                                        :: il_jghost
-      INTEGER(i4)      , DIMENSION(2)                    :: il_xghost
       INTEGER(i4)      , DIMENSION(3)                    :: il_dim
       INTEGER(i4)      , DIMENSION(3)                    :: il_size
@@ -1228,7 +1345,4 @@
       REAL(dp)         , DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
 
-      TYPE(TVAR)                                         :: tl_lon
-      TYPE(TVAR)                                         :: tl_lat
-      TYPE(TVAR)                                         :: tl_var
       TYPE(TDIM)       , DIMENSION(ip_maxdim)            :: tl_dim
 
@@ -1239,25 +1353,12 @@
       !----------------------------------------------------------------
 
-      !1- read output grid
-      tl_lon=iom_read_var(td_coord,'longitude')
-      tl_lat=iom_read_var(td_coord,'latitude')
-
-      !2- look for ghost cell
-      il_xghost(:)=grid_get_ghost( tl_lon, tl_lat )
-
-      il_ighost=il_xghost(1)*ig_ghost
-      il_jghost=il_xghost(2)*ig_ghost
-      
-      !3- write value on grid
-      !3-1 get matrix dimension
+      ! write value on grid
+      ! get matrix dimension
       il_dim(:)=td_var%t_dim(1:3)%i_len
-      !3-2 output dimension
-      tl_dim(:)=tl_lon%t_dim(:)
-
-      ! remove ghost cell
-      tl_dim(1)%i_len=tl_dim(1)%i_len - 2*il_xghost(1)*ig_ghost
-      tl_dim(2)%i_len=tl_dim(2)%i_len - 2*il_xghost(2)*ig_ghost
-
-      !3-3 split output domain in N subdomain depending of matrix dimension 
+
+      tl_dim(jp_I:jp_J)=dim_copy(td_dom%t_dim(jp_I:jp_J))
+      tl_dim(jp_K)%i_len=id_nlevel
+
+      ! split output domain in N subdomain depending of matrix dimension 
       il_size(:) = tl_dim(1:3)%i_len / il_dim(:)
       il_rest(:) = MOD(tl_dim(1:3)%i_len, il_dim(:))
@@ -1271,5 +1372,4 @@
       il_ishape(il_dim(1)+1)=il_ishape(il_dim(1)+1)+il_rest(1)
       
-
       ALLOCATE( il_jshape(il_dim(2)+1) )
       il_jshape(:)=0
@@ -1288,5 +1388,5 @@
       il_kshape(il_dim(3)+1)=il_kshape(il_dim(3)+1)+il_rest(3)
 
-      !3-3 write ouput table of value 
+      ! write ouput array of value 
       ALLOCATE(dl_value( tl_dim(1)%i_len, &
       &                  tl_dim(2)%i_len, &
